"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.reactImportsPlugin = void 0;
const path_1 = __importDefault(require("path"));
// Since React 17, importing React is optional.
// @vitejs/plugin-react adds the import automatically for .jsx/tsx files
// but not .js files.
const reactImportRegExp = /import (\* as )?React[ ,]/;
function reactImportsPlugin() {
    return {
        name: "previewjs:react-js-imports",
        async transform(code, id) {
            if (id.includes("node_modules") ||
                path_1.default.extname(id) !== ".js" ||
                reactImportRegExp.test(code)) {
                return code;
            }
            return `import React from 'react';${code}`;
        },
    };
}
exports.reactImportsPlugin = reactImportsPlugin;
